#!/bin/bash

ADDRESS_FILE=~/config/plugins/mbus/addresses.txt
BAUDRATE=2400
DEVICE=/dev/ttyUSB0
MQTT_HOST=192.168.1.10
MQTT_USER=loxberry
MQTT_PASS=your_mqtt_passowrd
MQTT_TOPIC=mbusmeters

if [ ! -f $ADDRESS_FILE ]; then
    mbus-serial-scan-secondary -b $BAUDRATE $DEVICE \
        | sed -e 's/^.*y address \([0-9A-Fa-f]\+\) .*$/\1/' > $ADDRESS_FILE
fi

echo -e "\n $(date)"
echo "Sending data to host $MQTT_HOST as user '$MQTT_USER' using topic '$MQTT_TOPIC/'."

while read ameter
do
    echo -n "Getting data from $ameter..."
    # The sed is for replacing the @ with _ to be able to match on it in HASS templates
    METER_DATA=$(mbus-serial-request-data-multi-reply -b $BAUDRATE $DEVICE $ameter | xq . | sed -e "s/@/_/")
    # echo -e "\n$METER_DATA"
    /usr/bin/mosquitto_pub -h $MQTT_HOST -u $MQTT_USER -P $MQTT_PASS \
        -t $MQTT_TOPIC/$ameter -m "${METER_DATA}"
    BYTCNT=$(echo "$METER_DATA" | wc -c)
    echo "  $BYTCNT bytes sent"
    echo "$METER_DATA" | jq '{ 
        id          : .MBusData.SlaveInformation.Id, 
        manufacturer: .MBusData.SlaveInformation.Manufacturer, 
        medium      : .MBusData.SlaveInformation.Medium, 
        records     : .MBusData.DataRecord | length  }'
done < <(cat $ADDRESS_FILE)